/* GCC */
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <map>
#include <algorithm>
#include <queue>
#include <sstream>

#define X first
#define Y second
#define mp(a, b) make_pair((a), (b))

using namespace std;

int m, n, i, j, k, wait, phase, a[260][260], v[510][510], x, y, t, px, py, kx, ky;
bool flag[510][510];
priority_queue < pair <int, pair <int, int> > > q;
const int inf = 1000000000;

int main()
{
    freopen("school.in", "r", stdin);
    freopen("school.out", "w", stdout);

    scanf("%d %d", &m, &n);
    for(i = n - 1; i >= 0; i--)
        for(j = 0; j < m; j++)
            scanf("%d", &a[i][j]);

    for(i = 0; i < 2 * n + 2; i++)
        for(j = 0; j < 2 * m + 2; j++)
        {
            if(i == 0 || i == 2 * n + 1 ||
               j == 0 || j == 2 * m + 1)
                v[i][j] = 0;
            else
                v[i][j] = inf;

            flag[i][j] = false;
        }

    q.push(mp(0, mp(1, 1)));
    while(flag[2 * n][2 * m] == false && !q.empty())
    {
        x = q.top().Y.X;
        y = q.top().Y.Y;
        t = -q.top().X;
        flag[x][y] = true;
        q.pop();

        k = a[(x - 1) / 2][(y - 1) / 2];
        phase = t % (2 * k);

        //=================================X===========================================
        if(x & 1 == 1)
        {
            px = x + 1; py = y;
            kx = x - 1; ky = y;
        }
        else
        {
            px = x - 1; py = y;
            kx = x + 1; ky = y;
        }
        wait = (phase < k ? k - phase : 0);

        if(v[px][py] > t + wait + 1)
        {
            v[px][py] = t + wait + 1;
            q.push(mp(-(t + wait + 1), mp(px, py)));
        }
        if(v[kx][ky] > t + 60)
        {
            v[kx][ky] = t + 60;
            q.push(mp(-(t + 60), mp(kx, ky)));
        }

        //=================================Y===========================================
        if(y & 1 == 1)
        {
            px = x; py = y + 1;
            kx = x; ky = y - 1;
        }
        else
        {
            px = x; py = y - 1;
            kx = x; ky = y + 1;
        }
        wait = (phase < k ? 0 : 2 * k - phase);

        if(v[px][py] > t + wait + 1)
        {
            v[px][py] = t + wait + 1;
            q.push(mp(-(t + wait + 1), mp(px, py)));
        }
        if(v[kx][ky] > t + 60)
        {
            v[kx][ky] = t + 60;
            q.push(mp(-(t + 60), mp(kx, ky)));
        }
    }

    printf("%d\n", v[2 * n][2 * m]);

    return 0;
}












