/* GCC */
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <map>
#include <algorithm>
#include <queue>
#include <sstream>

#define X first
#define Y second
#define mp(a, b) make_pair((a), (b))

using namespace std;

const int bit = 4;
const int M = 1 << bit;
int n, p, i, j, k, l, l0, l1, v[2][M][M];
bool a[M][M], b[M][M], c[bit], d[bit];

int main()
{
    freopen("chess.in", "r", stdin);
    freopen("chess.out", "w", stdout);

    for(i = 0; i < M; i++)
        for(j = 0; j < M; j++)
        {
            for(k = 0; k < bit; k++)
                c[k] = ((i >> k) & 1 == 1);
            for(k = 0; k < bit; k++)
                d[k] = ((j >> k) & 1 == 1);

            a[i][j] = !((c[0] && d[2]) ||
                        (c[1] && d[3]) ||
                        (c[2] && d[0]) ||
                        (c[3] && d[1]));

            b[i][j] = !(                  (c[0] && d[1]) ||
                        (c[1] && d[0]) || (c[1] && d[2]) ||
                        (c[2] && d[1]) || (c[2] && d[3]) ||
                        (c[3] && d[2]));
        }

    for(i = 0; i < M; i++)
        for(j = 0; j < M; j++)
            if(a[i][j] == true)
                v[0][i][j] = 1;
            else
                v[0][i][j] = 0;

    scanf("%d %d", &n, &p);

    l0 = 0;
    l1 = 1;
    for(l = 2; l < n; l++)
    {
        for(i = 0; i < M; i++)
        {
            for(j = 0; j < M; j++)
            {
                v[l1][i][j] = 0;

                if(a[i][j] == false)
                {
                    //cerr << 0 << " ";
                    continue;
                }

                for(k = 0; k < M; k++)
                    if(a[k][j] == true && b[k][i] == true)
                        v[l1][i][j] = (v[l1][i][j] + v[l0][j][k]) % p;

                //cerr << v[l1][i][j] << " ";
            }
            //cerr << endl;
        }
        //cerr << endl;

        l0 = 1 - l0;
        l1 = 1 - l1;
    }

    l = 0;
    for(i = 0; i < M; i++)
        for(j = 0; j < M; j++)
            l = (l + v[l0][i][j]) % p;
    printf("%d\n", l);

    return 0;
}









