/* GCC */
#include <fstream>

using namespace std;
size_t n, p, tmp, t[4], code;
size_t a[33][81][81], b[81], fin[2][81][81];
typedef unsigned long long int64;

void multiply(size_t m1[81][81], size_t m2[81][81], size_t res[81][81])
{
    for(size_t i = 0; i < 81; ++i)
        for(size_t j = 0; j < 81; ++j)
        {
            res[i][j] = 0;
            for(size_t k = 0; k < 81; ++k)
                (res[i][j] += (size_t)(((int64)(m1[i][k]) * (int64)(m2[k][j]))%p)) %= p;
        }
}

int main(void)
{
    for(size_t i = 0; i < 81; ++i)
    {
        for(size_t j = 0; j < 81; ++j)
            a[0][j][i] = 0, fin[0][j][i] = 0;
        tmp = i, fin[0][i][i] = 1;
        t[0] = tmp%3;
        t[1] = (tmp/=3)%3;
        t[2] = (tmp/=3)%3;
        t[3] = (tmp/=3)%3;
        for(size_t t0 = (t[2] == 2 ? 1 : 0); t0 < 3; t0 += 2)
        {
            if(t0 == 2 && (t[1] == 1 || t[3] == 1))
                break;
            for(size_t t1 = (t[3] == 2 ? 1 : 0); t1 < 3; t1 += 2)
            {
                if(t1 == 2 && t[2] == 1)
                    break;
                for(size_t t2 = (t[0] == 2 ? 1 : 0); t2 < 3; t2 += 2)
                {
                    if(t2 == 2 && t[1] == 1)
                        break;
                    for(size_t t3 = (t[1] == 2 ? 1 : 0); t3 < 3; t3 += 2)
                    {
                        if(t3 == 2 && (t[0] == 1 || t[2] == 1))
                            break;
                        code = 27*t3 + 9*t2 + 3*t1 + t0;
                        a[0][code][i] = 1;
                    }
                }
            }
        }
    }
    ifstream in("chess.in");
    in >> n >> p;
    in.close();
    size_t fin_idx, ans(0);
    n -= 2;
    {
        size_t i(0);
        while(n)
        {
            if(n&1)
                (i&1) ? multiply(a[i], fin[1], fin[0]) : multiply(a[i], fin[0], fin[1]);
            multiply(a[i], a[i], a[i+1]);
            ++i, n >>= 1;
        }
        if(i&1)
            fin_idx = 1;
        else
            fin_idx = 0;
    }
    for(size_t i = 0; i < 81; ++i)
        for(size_t j = 0; j < 81; ++j)
            (ans += fin[fin_idx][i][j]) %= p;
    ofstream out("chess.out");
    out << ans << '\n';
    out.close();
    return 0;
}
